#line 1 "SRC\\NestedVIC.c"
#line 1 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"










#line 33 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"










#line 49 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"











#line 66 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 75 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 95 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 123 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"









#line 145 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 170 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 179 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 198 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 210 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"



#line 228 "C:\\Keil\\ARM\\INC\\ADI\\ADuC7060.H"
 
typedef void (* tyVctHndlr) (void);

extern tyVctHndlr    IRQ;
extern tyVctHndlr    SWI;
extern tyVctHndlr    FIQ;
extern tyVctHndlr    UNDEF;
extern tyVctHndlr    PABORT;
extern tyVctHndlr    DABORT;
#line 2 "SRC\\NestedVIC.c"













#line 30 "SRC\\NestedVIC.c"



















#line 55 "SRC\\NestedVIC.c"












 

 
void IRQ0_FIQ_SOURCE (void);
void IRQ1_SW_INT     (void);
void IRQ3_T0_INT     (void);
void IRQ4_T1_INT     (void);  
void IRQ5_T2_INT     (void);
void IRQ6_T3_INT     (void);
void IRQ10_ADC_INT   (void);
void IRQ11_UART_INT  (void);
void IRQ12_SPIM_INT  (void);
void IRQ13_XIRQ0_INT (void);
void IRQ14_XIRQ1_INT (void);
void IRQ15_I2CM_INT  (void);
void IRQ16_I2CS_INT  (void);
void IRQ17_SPIS_INT  (void);
void IRQ18_XIRQ2_INT (void);
void IRQ19_XIRQ3_INT (void);
void IRQx_NULL_INT   (void);


 
void PAB_Function    (void);
void DAB_Function    (void);
void SWI_Function    (void);
void UNDEF_Function  (void);









 
typedef void (*tyIntHndlr)(void);  








 
const tyIntHndlr IntHndlrTable[32] __attribute__ ((aligned (128)))  = 
{
   IRQ0_FIQ_SOURCE,              
   IRQ1_SW_INT    ,              
   IRQx_NULL_INT  ,              
   IRQ3_T0_INT    ,              
   IRQ4_T1_INT    ,              
   IRQ5_T2_INT    ,              
   IRQ6_T3_INT    ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQ10_ADC_INT  ,              
   IRQ11_UART_INT ,              
   IRQ12_SPIM_INT  ,             
   IRQ13_XIRQ0_INT,              
   IRQ14_XIRQ1_INT,              
   IRQ15_I2CM_INT ,              
   IRQ16_I2CS_INT ,              
   IRQ17_SPIS_INT ,              
   IRQ18_XIRQ2_INT,              
   IRQ19_XIRQ3_INT,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
   IRQx_NULL_INT  ,              
};

static unsigned long ulLoop   = 0x0;





void Delay(void)
{
   volatile int iDelay = 0x0FFFF;

   while (iDelay--);
}





void  LedToggle(void)
{

   
   if (ulLoop%2)
     (*(volatile unsigned long *) 0xFFFF0D34) = 0x00400000;
   else
     (*(volatile unsigned long *) 0xFFFF0D38) = 0x00400000;

   ulLoop++;
}





int main(void)
{  
   unsigned long ulA,ulB, ulC;

   (*(volatile unsigned long *) 0xFFFF0D04) = 0x0;
   (*(volatile unsigned long *) 0xFFFF0D30) = 0xFF000000;

   (*(volatile unsigned long *) 0xFFFF0404)  = 0x1;
   (*(volatile unsigned long *) 0xFFFF0408)  = ((*(volatile unsigned long *) 0xFFFF0408) & ~0x3);
   (*(volatile unsigned long *) 0xFFFF040C)  = 0xF4;

   
   PABORT = PAB_Function;
   DABORT = DAB_Function;
   SWI    = SWI_Function;
   UNDEF  = UNDEF_Function;


   
   (*(volatile unsigned long *) 0xFFFF0014)           = (unsigned long)(((unsigned long)IntHndlrTable) >> 7);

   
   (*(volatile unsigned long *) 0xFFFF0030)           = (0x1UL << 0) |
                       (0x1UL << 1) ;

   
   (*(volatile unsigned long *) 0xFFFF0020)             = (0x3UL << 24)   | 
                       (0x5UL << 20)   |
                       (0x4UL << 16)   |
                       (0x2UL << 12)   |
                       (0x0UL << 4) ;

   (*(volatile unsigned long *) 0xFFFF0024)             = (0x0UL << 28) | 
                       (0x0UL << 24) |
                       (0x1UL << 20) |
                       (0x0UL << 16) |
                       (0x0UL << 12) |
                       (0x0UL << 8 ) ;

   (*(volatile unsigned long *) 0xFFFF0028)             = (0x0UL << 12) | 
                       (0x0UL << 8) |
                       (0x0UL << 4) |
                       (0x0UL << 0) ;

   
   (*(volatile unsigned long *) 0xFFFF0504)         = 0x0001;

   (*(volatile unsigned long *) 0xFFFF0514)          = 0x87;        
   (*(volatile unsigned long *) 0xFFFF050C)         = 0x8000;  

   (*(volatile unsigned long *) 0xFFFF0508)          = 0x01; 

   
   (*(volatile unsigned long *) 0xFFFF0034)           = 0x03;        

   
   (*(volatile unsigned long *) 0xFFFF0320)            = 0x300;       
   (*(volatile unsigned long *) 0xFFFF0328)           = 0x4C0;       


   
   (*(volatile unsigned long *) 0xFFFF0340)            = 0x300;       
   (*(volatile unsigned long *) 0xFFFF0348)           = 0x4C0;       

   
   (*(volatile unsigned long *) 0xFFFF0360)            = 0x500;       
   (*(volatile unsigned long *) 0xFFFF0368)           = 0x6C0;       

   
   (*(volatile unsigned long *) 0xFFFF0380)            = 0x320;       
   (*(volatile unsigned long *) 0xFFFF0388)           = 0xC1;


   
   (*(volatile unsigned long *) 0xFFFF0008)           = (1UL << 4)  |
                     (1UL << 5)  |
                     (1UL << 10) |
                     (1UL << 13);

   
   (*(volatile unsigned long *) 0xFFFF0108)           =    (1UL << 3)  |
                        (1UL << 6); 

   ulA = 0x3;
   ulB = 0x4;
   while (1)
     {
     ulC = ulA+ulB+ulC;
     
     LedToggle();
     Delay();
     }
}





void IRQ0_FIQ_SOURCE (void)
{
   while(1); 
}





void IRQ1_SW_INT     (void)
{
   while(1); 
}





void IRQ3_T0_INT     (void)
{
   (*(volatile unsigned long *) 0xFFFF032C) = 0xFF;
}





void IRQ4_T1_INT     (void)  
{
   
   (*(volatile unsigned long *) 0xFFFF034C) = 0xFF;
}





void IRQ5_T2_INT     (void)
{
   
   (*(volatile unsigned long *) 0xFFFF036C) = 0xFF;
}





void IRQ6_T3_INT     (void)
{
   
   (*(volatile unsigned long *) 0xFFFF038C) = 0xFF;
}





void IRQ10_ADC_INT   (void)
{
   
   if((*(volatile unsigned long *) 0xFFFF0500) & 0x1)
      (void)(*(volatile unsigned long *) 0xFFFF051C);
   if((*(volatile unsigned long *) 0xFFFF0500) & 0x2)
      (void)(*(volatile unsigned long *) 0xFFFF0520);
}





void IRQ11_UART_INT  (void)
{
   while(1); 
}





void IRQ12_SPIM_INT  (void)
{
   while(1); 
}





void IRQ13_XIRQ0_INT (void)
{
   
   (*(volatile unsigned long *) 0xFFFF0038) = 0x1UL << 13;
}





void IRQ14_XIRQ1_INT (void)
{
   
   (*(volatile unsigned long *) 0xFFFF0038) = 0x1UL << 14;
}





void IRQ15_I2CM_INT  (void)
{
   while(1); 
}





void IRQ16_I2CS_INT  (void)
{
   while(1); 
}





void IRQ17_SPIS_INT  (void)
{
   while(1); 
}





void IRQ18_XIRQ2_INT (void)
{
   
   (*(volatile unsigned long *) 0xFFFF0038) = 0x1UL << 18;
}





void IRQ19_XIRQ3_INT (void)
{
   
   (*(volatile unsigned long *) 0xFFFF0038) = 0x1UL << 19;
}





void IRQx_NULL_INT   (void)
{
   
   while(1); 
}






void PAB_Function(void)
{
   
   while(1); 
}





void DAB_Function(void)
{
   
   while(1); 
}






void SWI_Function(void)
{
   
   while(1); 
}






void UNDEF_Function(void)
{
   
   while(1); 
}




